﻿Public Class Form1

  Dim stepsize As Integer = 5
  Dim steamcol As Color = Color.Pink
  Dim exhaustcol As Color = Color.PowderBlue
  Dim steambrush As New SolidBrush(steamcol)
  Dim exhaustbrush As New SolidBrush(exhaustcol)
  Dim whitebrush As New SolidBrush(Color.White)
  Dim leftbrush As New SolidBrush(Color.White)
  Dim rightbrush As New SolidBrush(Color.White)

  Dim ppen As New Pen(Color.Black, 4)
  Dim vpen As New Pen(Color.Brown, 2)
  Dim apengreen As New Pen(Color.Green, 4)
  Dim apenbrown As New Pen(Color.RosyBrown, 4)
  Dim vectorpen1 As New Pen(Color.Black, 4)
  Dim vectorpen2 As New Pen(Color.Brown, 4)
  Dim Valvebrush As New SolidBrush(Color.Brown)

  Dim px1, px2, px3 As Integer
  Dim vx1, vx2, vx3 As Integer
  Dim Lap As Integer
  Dim Lead As Integer
  Dim forward As Single
  Dim reverse As Single
  Dim pistonphase As Single
  Dim valvephase As Single
  Dim valveamp As Single
  Dim valvefactor As Single = 1 ' setting this to larger values increases the amplitude of the vale stroke and the lap accordingly

  Private Sub Form1_Load(sender As Object, e As System.EventArgs) Handles Me.Load
    Timer1.Interval = 20
    apengreen.EndCap = Drawing2D.LineCap.ArrowAnchor
    apenbrown.EndCap = Drawing2D.LineCap.ArrowAnchor
    vectorpen1.EndCap = Drawing2D.LineCap.RoundAnchor
    vectorpen2.EndCap = Drawing2D.LineCap.RoundAnchor
    RichTextBox1.Rtf = My.Resources.Stephenson
  End Sub

  Private Sub CalculateParameters()
    Lap = LapNUD.Value
    If StephensonRB.Checked Then
      Dim theta As Single
      Dim phi As Single
      Lead = LeadNUD.Value
      theta = (90 - Lead) * Math.PI / 180
      Dim P As Single = 100 * Math.Cos(theta)
      Dim Q As Single = ReversingTB.Value * Math.Sin(theta)
      If P < 1 Then
        phi = 90 * Math.Sign(Q)
      Else
        phi = 180 * Math.Atan(Q / P) / Math.PI
      End If
      valvephase = 180 - phi
      valveamp = Math.Sqrt(P ^ 2 + Q ^ 2)
    Else
      Dim s As Integer = LeadNUD.Value
      Dim t As Integer = ReversingTB.Value * (100 - s) \ 100
      If s = 0 Then
        valvephase = 180 - 90 * Math.Sign(ReversingTB.Value)
      Else
        valvephase = 180 - 180 * Math.Atan(t / s) / Math.PI
      End If
      valveamp = Math.Sqrt(t ^ 2 + s ^ 2)
    End If
  End Sub

  Private Sub PictureBox1_Paint(sender As Object, e As System.Windows.Forms.PaintEventArgs) Handles PictureBox1.Paint
    e.Graphics.TranslateTransform(240, 460)
    e.Graphics.FillRectangle(Brushes.Gainsboro, -Lap, -440, 2 * Lap, 440)
    DrawAxes(e.Graphics)
    For x As Integer = 0 To 440 Step stepsize
      px1 = Sin(100, x - stepsize / 2, 0) : px2 = Sin(100, x + stepsize / 2, 0) : px3 = Sin(100, x, 0)
      vx1 = Sin(valveamp, x - stepsize / 2, valvephase) : vx2 = Sin(valveamp, x + stepsize / 2, valvephase) : vx3 = Sin(valveamp, x, valvephase)
      Select Case True
        Case vx3 = 0
          ' left closed; right closed
        Case vx3 > Lap
          ' left steam; right exhaust
          e.Graphics.FillRectangle(steambrush, -220, -(x + stepsize \ 2), 40, stepsize)
          e.Graphics.FillRectangle(exhaustbrush, 180, -(x + stepsize \ 2), 40, stepsize)
          If x > 110 And x < 330 Then
            e.Graphics.DrawLine(apengreen, px3, -x, px3 + 20, -x)
          Else
            e.Graphics.DrawLine(apenbrown, px3, -x, px3 + 20, -x)
          End If
        Case vx3 > 0
          ' Left closed; right exhaust
          e.Graphics.FillRectangle(exhaustbrush, 180, -(x + stepsize \ 2), 40, stepsize)
        Case vx3 < -Lap
          ' left exhaust; right steam
          e.Graphics.FillRectangle(exhaustbrush, -220, -(x + stepsize \ 2), 40, stepsize)
          e.Graphics.FillRectangle(steambrush, 180, -(x + stepsize \ 2), 40, stepsize)
          If x > 110 And x < 330 Then
            e.Graphics.DrawLine(apenbrown, px3, -x, px3 - 20, -x)
          Else
            e.Graphics.DrawLine(apengreen, px3, -x, px3 - 20, -x)
          End If
        Case vx3 < 0
          ' left exhaust; right closed
          e.Graphics.FillRectangle(exhaustbrush, -220, -(x + stepsize \ 2), 40, stepsize)
      End Select
      e.Graphics.DrawLine(vpen, vx1, -(x - stepsize \ 2), vx2, -(x + stepsize \ 2))
      e.Graphics.DrawLine(ppen, px1, -(x - stepsize \ 2), px2, -(x + stepsize \ 2))
    Next
    e.Graphics.DrawLine(Pens.Black, -120, -440 * pistonphase \ 360, 120, -440 * pistonphase \ 360)
  End Sub

  Private Sub DrawAxes(g As Graphics)
    Dim p As New Pen(Brushes.Black, 4)
    g.DrawLine(p, -160, 0, 160, 0)
    g.DrawLine(p, 0, 0, 0, -440)
    g.DrawLine(p, -160, -440, 160, -440)
  End Sub

  Private Function Sin(amp As Integer, x As Integer, phase As Integer) As Integer
    Return -amp * Math.Sin(2 * Math.PI * x / 440 + Math.PI * phase / 180)
  End Function

  Private Sub PictureBox2_Paint(sender As Object, e As System.Windows.Forms.PaintEventArgs) Handles PictureBox2.Paint
    e.Graphics.TranslateTransform(240, 80)
    DrawChest(e.Graphics)
    vx3 = Sin(valveamp, 440 * pistonphase \ 360, valvephase)
    Select Case True
      Case vx3 = 0
        ' left closed; right closed
        leftbrush = whitebrush : rightbrush = whitebrush
      Case vx3 > Lap
        ' left steam; right exhaust
        leftbrush = steambrush : rightbrush = exhaustbrush
      Case vx3 > 0
        ' Left closed; right exhaust
        leftbrush = whitebrush : rightbrush = exhaustbrush
      Case vx3 < -Lap
        ' left exhaust; right steam
        leftbrush = exhaustbrush : rightbrush = steambrush
      Case vx3 < 0
        ' left exhaust; right closed
        leftbrush = exhaustbrush : rightbrush = whitebrush
    End Select
    DrawPiston(e.Graphics, -100 * Math.Sin(Math.PI * pistonphase / 180), leftbrush, rightbrush)
    DrawValve(e.Graphics, -valveamp * valvefactor / 10 * Math.Sin(Math.PI * (pistonphase + valvephase) / 180), Lap)
  End Sub

  Private Sub DrawChest(g As Graphics)
    g.FillRectangle(Brushes.DarkGray, -130, -70, 260, 140)
    g.FillRectangle(steambrush, -120, -60, 240, 30)
    g.FillRectangle(exhaustbrush, -20, -30, 40, 20)
  End Sub

  Private Sub DrawPiston(g As Graphics, x As Integer, leftbr As SolidBrush, rightbr As SolidBrush)
    g.FillRectangle(Brushes.Black, x - 10, 0, 20, 60)

    g.FillRectangle(leftbr, -120, 0, 120 + x - 10, 60)
    g.FillRectangle(leftbr, -120, -20, 10, 20)
    g.FillRectangle(leftbr, -120, -20, 70, 10)
    g.FillRectangle(leftbr, -60, -30, 10, 20)

    g.FillRectangle(rightbr, x + 10, 0, 120 - x - 10, 60)
    g.FillRectangle(rightbr, 110, -20, 10, 20)
    g.FillRectangle(rightbr, 50, -20, 70, 10)
    g.FillRectangle(rightbr, 50, -30, 10, 20)
  End Sub

  Private Sub DrawValve(g As Graphics, x As Integer, lap As Integer)
    g.FillRectangle(Valvebrush, x - 60, -50, 120, 10)
    g.FillRectangle(Valvebrush, x - 60 - lap * valvefactor \ 10, -40, 10 + lap * valvefactor \ 10, 10)
    g.FillRectangle(Valvebrush, x + 50, -40, 10 + lap * valvefactor \ 10, 10)
    g.FillRectangle(exhaustbrush, x - 50, -40, 100, 10)
  End Sub

  Private Sub PictureBox3_Paint(sender As Object, e As System.Windows.Forms.PaintEventArgs) Handles PictureBox3.Paint
    e.Graphics.TranslateTransform(80, 80)
    e.Graphics.DrawEllipse(Pens.Black, -70, -70, 140, 140)
    If StephensonRB.Checked Then
      VectorTriangle(e.Graphics)
    Else
      VectorTriangle2(e.Graphics)
    End If
    DrawVector(e.Graphics, vectorpen1, 70, pistonphase)
    DrawVector(e.Graphics, vectorpen2, 70 * valveamp / 100, pistonphase + valvephase)
  End Sub

  Private Sub DrawVector(g As Graphics, vpen As Pen, length As Single, phase As Single)
    phase = 2 * Math.PI * phase / 360
    g.DrawLine(vpen, 0, 0, CInt(-length * Math.Sin(phase)), CInt(-length * Math.Cos(phase)))
  End Sub

  Private Sub VectorTriangle(g As Graphics)
    Dim length As Single = 70 * (100 + ReversingTB.Value) / 200
    Dim phase As Single = 2 * Math.PI * (pistonphase + 90 + Lead) / 360
    Dim A As New PointF(-length * Math.Sin(phase), -length * Math.Cos(phase))
    Dim P As New PointF(-70 * Math.Sin(phase), -70 * Math.Cos(phase))
    length = 70 * (100 - ReversingTB.Value) / 200
    phase = 2 * Math.PI * (pistonphase - 90 - Lead) / 360
    Dim B As New PointF(-length * Math.Sin(phase), -length * Math.Cos(phase))
    Dim Q As New PointF(-70 * Math.Sin(phase), -70 * Math.Cos(phase))
    Dim C As New PointF(A.X + B.X, A.Y + B.Y)
    g.DrawLine(Pens.Black, New PointF(0, 0), A)
    g.DrawLine(Pens.Black, New PointF(0, 0), B)
    g.DrawLine(Pens.Black, A, C)
    g.DrawLine(Pens.Black, B, C)
    g.DrawLine(Pens.Black, P, Q)
  End Sub

  Private Sub VectorTriangle2(g As Graphics)
    Dim s As Integer = 70 * LeadNUD.Value / 100
    Dim t As Integer = 70 * ReversingTB.Value * (100 - LeadNUD.Value) / 10000
    Dim A As New PointF(0, t)
    Dim B As New PointF(s, 0)
    Dim P As New PointF(s, 70 * (100 - LeadNUD.Value) / 100)
    Dim Q As New PointF(s, -70 * (100 - LeadNUD.Value) / 100)
    Dim C As New PointF(A.X + B.X, A.Y + B.Y)
    g.DrawLine(Pens.Black, New PointF(0, 0), A)
    g.DrawLine(Pens.Black, New PointF(0, 0), B)
    g.DrawLine(Pens.Black, A, C)
    g.DrawLine(Pens.Black, P, Q)
  End Sub

  Private Sub ReversingTB_Scroll(sender As System.Object, e As System.EventArgs) Handles ReversingTB.ValueChanged
    CalculateParameters()
    PictureBox1.Invalidate()
    PictureBox2.Invalidate()
    PictureBox3.Invalidate()
  End Sub

  Private Sub LapNUD_ValueChanged(sender As System.Object, e As System.EventArgs) Handles LapNUD.ValueChanged
    If CoupleCB.Checked Then
      If StephensonRB.Checked Then
        LeadNUD.Value = CInt(Math.Asin(LapNUD.Value / 100) * 180 / Math.PI)
      Else
        LeadNUD.Value = LapNUD.Value
      End If
    Else
      CalculateParameters()
      PictureBox1.Invalidate()
      PictureBox2.Invalidate()
      PictureBox3.Invalidate()
    End If
  End Sub

  Private Sub LeadNUD_ValueChanged(sender As System.Object, e As System.EventArgs) Handles LeadNUD.ValueChanged
    CalculateParameters()
    PictureBox1.Invalidate()
    PictureBox2.Invalidate()
    PictureBox3.Invalidate()
  End Sub

  Private Sub AnimateCB_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles AnimateCB.CheckedChanged
    If AnimateCB.Checked Then Timer1.Start() Else Timer1.Stop()
  End Sub

  Private Sub Timer1_Tick(sender As Object, e As System.EventArgs) Handles Timer1.Tick
    pistonphase = (pistonphase + 2 * Math.Sign(ReversingTB.Value) + 360) Mod 360
    CalculateParameters()
    PictureBox1.Invalidate()
    PictureBox2.Invalidate()
    PictureBox3.Invalidate()
  End Sub

  Private Sub Button1_Click(sender As System.Object, e As System.EventArgs) Handles Button1.Click
    pistonphase = (pistonphase + 10) Mod 360
    CalculateParameters()
    PictureBox1.Invalidate()
    PictureBox2.Invalidate()
    PictureBox3.Invalidate()
  End Sub

  Private Sub CoupleCB_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles CoupleCB.CheckedChanged
    If CoupleCB.Checked Then
      LeadNUD.Value = CInt(Math.Asin(LapNUD.Value / 100) * 180 / Math.PI)
      LeadNUD.Enabled = False
    Else
      LeadNUD.Enabled = True
    End If
  End Sub

  Private Sub StephensonRB_CheckedChanged(sender As System.Object, e As System.EventArgs) Handles StephensonRB.CheckedChanged
    pistonphase = 90
    If StephensonRB.Checked Then
      Label5.Text = "Lead (°)"
      RichTextBox1.Rtf = My.Resources.Stephenson
      LeadNUD.Maximum = 90
    Else
      Label5.Text = "Combination (%)"
      RichTextBox1.Rtf = My.Resources.Walschaerts
      LeadNUD.Maximum = 100
    End If
    If CoupleCB.Checked Then
      If StephensonRB.Checked Then
        LeadNUD.Value = CInt(Math.Asin(LapNUD.Value / 100) * 180 / Math.PI)
      Else
        LeadNUD.Value = LapNUD.Value
      End If
    End If
    CalculateParameters()
    PictureBox1.Invalidate()
    PictureBox2.Invalidate()
    PictureBox3.Invalidate()
  End Sub
End Class
